// $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
// pat_exhau* test

union <'a>list {
	void Nil;
	*['a, <'a>list] Cons;
}

<'a>list map2a(*('a ('b, 'c)) f, <'b>list l1, <'c>list l2)
{
	switch [l1, l2] {
	case [Cons[x, xs], Cons[y, ys]]:
		return Cons[f(x, y), map2a(f, xs, ys)];
	case [Nil, Nil]:
		return Nil;
	case [Cons[_,_], Nil]:
		return Nil;
	case [Nil, Cons[_,_]]:
		return Nil;
	}
}

<'a>list map2b(*('a ('b, 'c)) f, <'b>list l1, <'c>list l2)
{
	switch [l1, l2] {
	case [Cons[x, xs], Cons[y, ys]]:
		return Cons[f(x, y), map2b(f, xs, ys)];
	case [Nil, Nil]:
		return Nil;
	case [Nil, Cons[_,_]]:
		return Nil;
	case [Cons[_,_], Nil]:
		return Nil;
	}
}

<'a>list map2c(*('a ('b, 'c)) f, <'b>list l1, <'c>list l2)
{
	switch [l1, l2] {
	case [Cons[x, xs], Cons[y, ys]]:
		return Cons[f(x, y), map2c(f, xs, ys)];
	case [Nil, Nil]:
		return Nil;
	case [_,_]:
		return Nil;
	}
}

/* 
 * expected-build-status: ok
 * run-test: no
 */
